//+------------------------------------------------------------------+
//|                                                VininI_gqowex.mq4 |
//|                                         Copyright  2012, Vinin. |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Vinin."
#property link      "vinin@mail.ru"
/*
input length = 20;
input cumlength = 13;

closeLog = log(close[1] / close[2]);
SDev = stdev(closeLog, length) * Sqrt(close[length] / close[length - 1]);
x = SDev * close[1];
spike = (close[0] - close[1]) / x;

y = if spike > 0 then spike else 0;

up = sum(y, cumlength);
z = if spike <= 0 then spike else 0;
dn = sum(AbsValue(z), cumlength);//     z   - cumlength

    spikeLimit = if spike > 3 then 3 else if spike < -3 then -3 else spike;

    spikeOsc = (up - dn)/3;

           SpikeOsc    ....
     ....   .

*/

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 Lime
#property indicator_color4 Lime
#property indicator_level1 0

//--- input parameters
extern int       length=20;
extern int       cumlength=20;
extern int       BBlength=20;
extern double    BBk=1.0;
//--- buffers
double spikeLimit[];
double spikeOsc[];
double spikeOscUP[];
double spikeOscDN[];
double closeLog[];
double y[], z[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(7);
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,spikeLimit);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,spikeOsc);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,spikeOscUP);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,spikeOscDN);
   


   SetIndexBuffer(4,closeLog);
   SetIndexBuffer(5,y);
   SetIndexBuffer(6,z);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    i, counted_bars=IndicatorCounted();
//----
   int limit=Bars-counted_bars-1;
   if (limit>1) limit=Bars-length-3;
   
   for (i=limit;i>=0;i--) closeLog[i]=MathLog(Close[i+1])-MathLog(Close[i+2]);
   for (i=limit;i>=0;i--) {
      double SDev = iStdDevOnArray(closeLog, 0, length, 0, MODE_SMA, i) * MathSqrt(Close[i+length] / Close[i+length - 1]);
      double x = SDev * Close[i+1];
      double spike = (Close[i] - Close[i+1]) / x;
      
      spikeLimit[i] = MathMax( -3, MathMin(3, spike));

      y[i] = MathMax(0, spike);
      z[i] = MathMin(0, spike);
   }
   for (i=limit;i>=0;i--) {
      double up = iMAOnArray(y,0, cumlength, 0, MODE_SMA, i)*cumlength;
      double dn = iMAOnArray(z,0, cumlength, 0, MODE_SMA, i)*cumlength;
      spikeOsc[i] = (up + dn)/3.0;
   }
   for (i=limit;i>=0;i--) {
      SDev=iStdDevOnArray(spikeOsc, 0, BBlength, 0, MODE_SMA,i);
      spikeOscUP[i]=spikeOsc[i]+SDev*BBk;
      spikeOscDN[i]=spikeOsc[i]-SDev*BBk;
   }

   
//----
   return(0);
  }
//+------------------------------------------------------------------+